Foxit PDF SDK

Public Member Functions | Static Public Attributes | List of all members
com.foxit.sdk.pdf.annots.Markup Class Reference
Inheritance diagram for com.foxit.sdk.pdf.annots.Markup:

## Public Member Functions
| Markup ()
| Constructor.
| Markup (Annot annot)
| Constructor, with parent class object. More...
Note | addReply () throws com.foxit.sdk.PDFException
| Add a new reply to the end of reply list. More...
void | addRichText (String content, RichTextStyle style) throws com.foxit.sdk.PDFException
| Add a new rich text string to the end. More...
Note | addStateAnnot (String title, int model, int state) throws com.foxit.sdk.PDFException
| Add a new state annotation. More...
synchronized void | delete ()
| Clean up related C++ resources immediately. More...
float | getBorderOpacity () throws com.foxit.sdk.PDFException
| Get the border opacity of the annotation. More...
DateTime | getCreationDateTime () throws com.foxit.sdk.PDFException
| Get creation date time. More...
float | getFillOpacity () throws com.foxit.sdk.PDFException
| Get the fill opacity of the annotation. More...
MarkupArray | getGroupElements () throws com.foxit.sdk.PDFException
| Get an element (as markup annotation) from the group that current markup annotation belongs to. More...
Markup | getGroupHeader () throws com.foxit.sdk.PDFException
| Get the header annotation (as primary annotation) of the group that current markup annotation belongs to. More...
String | getIntent () throws com.foxit.sdk.PDFException
| Get intent name. More...
float | getOpacity () throws com.foxit.sdk.PDFException
| Get opacity value. More...
Popup | getPopup () throws com.foxit.sdk.PDFException
| Get related pop-up annotation. More...
Note | getReply (int index) throws com.foxit.sdk.PDFException
| Get a reply by index. More...
int | getReplyCount () throws com.foxit.sdk.PDFException
| Count all replies. More...
String | getRichTextContent (int index) throws com.foxit.sdk.PDFException
| Get text string of a rich text string specified by index. More...
int | getRichTextCount () throws com.foxit.sdk.PDFException
| Get the count of rich text strings. More...
RichTextStyle | getRichTextStyle (int index) throws com.foxit.sdk.PDFException
| Get style data of a rich text string specified by index. More...
NoteArray | getStateAnnots (int model) throws com.foxit.sdk.PDFException
| Get all state annotations in a specified state model. More...
String | getSubject () throws com.foxit.sdk.PDFException
| Get subject string. More...
String | getTitle () throws com.foxit.sdk.PDFException
| Get title string. More...
void | insertRichText (int index, String content, RichTextStyle style) throws com.foxit.sdk.PDFException
| Insert a new rich text string to the place which is specified by index. More...
boolean | isGrouped () throws com.foxit.sdk.PDFException
| Check whether current markup annotation is in a group or not. More...
boolean | removeAllReplies () throws com.foxit.sdk.PDFException
| Remove all the replies. More...
boolean | removeAllStateAnnots () throws com.foxit.sdk.PDFException
| Remove all the state annotations. More...
boolean | removePopup () throws com.foxit.sdk.PDFException
| Remove related pop-up annotation. More...
boolean | removeReply (int index) throws com.foxit.sdk.PDFException
| Remove a reply by index. More...
void | removeRichText (int index) throws com.foxit.sdk.PDFException
| Remove a rich text string specified by index. More...
void | setBorderOpacity (float opacity) throws com.foxit.sdk.PDFException
| Set the border opacity of the annotation. More...
void | setCreationDateTime (DateTime date_time) throws com.foxit.sdk.PDFException
| Set creation date time. More...
void | setFillOpacity (float opacity) throws com.foxit.sdk.PDFException
| Set the fill opacity of the annotation. More...
void | setIntent (String intent) throws com.foxit.sdk.PDFException
| Set intent name. More...
void | setOpacity (float opacity) throws com.foxit.sdk.PDFException
| Set opacity value. More...
void | setPopup (Popup popup) throws com.foxit.sdk.PDFException
| Set related pop-up annotation. More...
void | setRichTextContent (int index, String content) throws com.foxit.sdk.PDFException
| Set text string of a rich text string specified by index. More...
void | setRichTextStyle (int index, RichTextStyle style) throws com.foxit.sdk.PDFException
| Set style data of a rich text string specified by index. More...
void | setSubject (String subject) throws com.foxit.sdk.PDFException
| Set subject string. More...
void | setTitle (String title) throws com.foxit.sdk.PDFException
| Set title string. More...
boolean | ungroup () throws com.foxit.sdk.PDFException
| Ungroup current markup annotation from the group it belongs to. More...
Public Member Functions inherited from com.foxit.sdk.pdf.annots.Annot
| Annot ()
| Constructor.
| Annot (Annot annot)
| Constructor, with another annotation object. More...
| Annot (PDFPage page, PDFDictionary annot_dict) throws com.foxit.sdk.PDFException
| Constructor, with PDF page and annotation's PDF dictionary. More...
PDFStream | getAppearanceStream (int type, String appearance_state) throws com.foxit.sdk.PDFException
| Get annotation's appearance stream with specified type and state. More...
long | getBorderColor () throws com.foxit.sdk.PDFException
| Get border color. More...
BorderInfo | getBorderInfo () throws com.foxit.sdk.PDFException
| Get border information. More...
String | getContent () throws com.foxit.sdk.PDFException
| Get content. More...
RectI | getDeviceRect (Matrix2D matrix) throws com.foxit.sdk.PDFException
| Get annotation rectangle in device coordinate system. More...
PDFDictionary | getDict () throws com.foxit.sdk.PDFException
| Get annotation's dictionary object. More...
Matrix2D | getDisplayMatrix (Matrix2D page_display_matrix) throws com.foxit.sdk.PDFException
| Get the display matrix, from PDF coordinate system to targeted device coordinate system. More...
int | getFlags () throws com.foxit.sdk.PDFException
| Get annotation flags. More...
int | getIndex () throws com.foxit.sdk.PDFException
| Get the index of current annotation in the page which current annotation belongs to. More...
DateTime | getModifiedDateTime () throws com.foxit.sdk.PDFException
| Get last modified date time. More...
PDFDictionary | getOptionalContent () throws com.foxit.sdk.PDFException
| Get the PDF dictionary of annotation's optional content. More...
PDFPage | getPage () throws com.foxit.sdk.PDFException
| Get the related PDF page. More...
RectF | getRect () throws com.foxit.sdk.PDFException
| Get rectangle, in PDF coordinate system. More...
int | getType () throws com.foxit.sdk.PDFException
| Get actual annotation type of current annotation. More...
String | getUniqueID () throws com.foxit.sdk.PDFException
| Get unique ID. More...
boolean | hasProperty (int property) throws com.foxit.sdk.PDFException
| Whether current annotation has the specified annotation's property. More...
boolean | isEmpty ()
| Check whether current object is empty or not. More...
boolean | isMarkup () throws com.foxit.sdk.PDFException
| Check if current annotation is a markup annotation. More...
boolean | move (RectF rect) throws com.foxit.sdk.PDFException
| Move current annotation to a new position, specified by a new rectangle in PDF coordinate system. More...
boolean | move (RectF rect, boolean is_reset_appearance) throws com.foxit.sdk.PDFException
| Move current annotation to a new position, specified by a new rectangle in PDF coordinate system. More...
boolean | removeProperty (int property) throws com.foxit.sdk.PDFException
| Remove a specified annotation's property. More...
boolean | resetAppearanceStream () throws com.foxit.sdk.PDFException
| Reset appearance stream. More...
boolean | resetAppearanceStream (boolean is_generate_new_appearance_obj) throws com.foxit.sdk.PDFException
| Reset appearance stream. More...
void | setBorderColor (long color) throws com.foxit.sdk.PDFException
| Set border color. More...
void | setBorderInfo (BorderInfo border) throws com.foxit.sdk.PDFException
| Set border information. More...
void | setContent (String content) throws com.foxit.sdk.PDFException
| Set content. More...
void | setFlags (int flags) throws com.foxit.sdk.PDFException
| Set annotation flags. More...
void | setModifiedDateTime (DateTime date_time) throws com.foxit.sdk.PDFException
| Set last modified date time. More...
void | setUniqueID (String unique_id) throws com.foxit.sdk.PDFException
| Set unique ID. More...

## Static Public Attributes
static final int | e_EndingStyleButt = 6
| A short line at the endpoint perpendicular to the line itself.
static final int | e_EndingStyleCircle = 2
| A circle filled with the annotation's interior color if any.
static final int | e_EndingStyleClosedArrow = 5
| Two short lines meeting in an acute angle as in the OpenArrow style and connected by a third line to form a triangular closed arrowhead filled with the annotation's interior color if any.
static final int | e_EndingStyleDiamond = 3
| A diamond shape filled with the annotation's interior color if any.
static final int | e_EndingStyleNone = 0
| No special line ending.
static final int | e_EndingStyleOpenArrow = 4
| Two short lines meeting in an acute angle to form an open arrowhead.
static final int | e_EndingStyleRClosedArrow = 8
| A triangular closed arrowhead in the reverse direction from ClosedArrow.
static final int | e_EndingStyleROpenArrow = 7
| Two short lines in the reverse direction from OpenArrow.
static final int | e_EndingStyleSlash = 9
| A short line at the endpoint approximately 30 degrees clockwise from perpendicular to the line itself.
static final int | e_EndingStyleSquare = 1
| A square filled with the annotation's interior color if any.
static final int | e_MeasureTypeA = 3
| Measurement of area.
static final int | e_MeasureTypeD = 2
| Measurement of distance in any direction.
static final int | e_MeasureTypeS = 5
| Measurement of the slope of a line.
static final int | e_MeasureTypeT = 4
| Measurement of angles.
static final int | e_MeasureTypeX = 0
| Measurement of change along the x axis.
static final int | e_MeasureTypeY = 1
| Measurement of change along the y axis.
static final int | e_StateAccepted = 3
| (Used with state model com.foxit.sdk.pdf.annots.Markup.e_StateModelReview ) The user agrees with the change.
static final int | e_StateCancelled = 5
| (Used with state model com.foxit.sdk.pdf.annots.Markup.e_StateModelReview ) The change has been cancelled.
static final int | e_StateCompleted = 6
| (Used with state model com.foxit.sdk.pdf.annots.Markup.e_StateModelReview ) The change has been completed.
static final int | e_StateDeferred = 7
| (Used with state model com.foxit.sdk.pdf.annots.Markup.e_StateModelReview ) The change has been deferred.
static final int | e_StateFuture = 8
| (Used with state model com.foxit.sdk.pdf.annots.Markup.e_StateModelReview ) The change will be working in the future.
static final int | e_StateMarked = 1
| (Used with state model com.foxit.sdk.pdf.annots.Markup.e_StateModelMarked ) The annotation has been marked by the user.
static final int | e_StateModelMarked = 1
| Markup annotation state model: marked.
static final int | e_StateModelReview = 2
| Markup annotation state model: review.
static final int | e_StateNone = 0
| (Used with state model com.foxit.sdk.pdf.annots.Markup.e_StateModelReview ) The user has indicated nothing about the change.
static final int | e_StateRejected = 4
| (Used with state model com.foxit.sdk.pdf.annots.Markup.e_StateModelReview ) The user disagrees with the change.
static final int | e_StateUnmarked = 2
| (Used with state model com.foxit.sdk.pdf.annots.Markup.e_StateModelMarked ) The annotation has not been marked by the user.
Static Public Attributes inherited from com.foxit.sdk.pdf.annots.Annot
static final int | e_3D = 25
| Annotation type: 3D annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_AppearanceTypeDown = 2
| Annotation's down appearance.
static final int | e_AppearanceTypeNormal = 0
| Annotation's normal appearance.
static final int | e_AppearanceTypeRollover = 1
| Annotation's rollover appearance.
static final int | e_Caret = 14
| Annotation type: caret annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Circle = 6
| Annotation type: circle annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_FileAttachment = 17
| Annotation type: file attachment annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_FlagHidden = 0x0002
| Annotation flag: hidden. More...
static final int | e_FlagInvisible = 0x0001
| Annotation flag: invisible. More...
static final int | e_FlagLocked = 0x0080
| Annotation flag: locked. More...
static final int | e_FlagLockedContents = 0x0200
| Annotation flag: locked contents. More...
static final int | e_FlagNoRotate = 0x0010
| Annotation flag: no rotate. More...
static final int | e_FlagNoView = 0x0020
| Annotation flag: no view. More...
static final int | e_FlagNoZoom = 0x0008
| Annotation flag: no zoom. More...
static final int | e_FlagPrint = 0x0004
| Annotation flag: print. More...
static final int | e_FlagReadOnly = 0x0040
| Annotation flag: read only. More...
static final int | e_FlagToggleNoView = 0x0100
| Annotation flag: toggle no view. More...
static final int | e_FreeText = 3
| Annotation type: free text annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Highlight = 9
| Annotation type: highlight annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_HighlightingInvert = 1
| Highlighting mode: Invert, which is to invert the contents of the annotation rectangle.
static final int | e_HighlightingNone = 0
| Highlighting mode: No highlighting.
static final int | e_HighlightingOutline = 2
| Highlighting mode: Outline, which is to invert the annotation's border.
static final int | e_HighlightingPush = 3
| Highlighting mode: Push, which is to display the annotation's down appearance, if any.
static final int | e_HighlightingToggle = 4
| Highlighting mode: Toggle. This is only useful for widget annotation.
static final int | e_Ink = 15
| Annotation type: ink annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Line = 4
| Annotation type: line annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Link = 2
| Annotation type: link annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_MKEntryBackgroundColor = 2
| Background color entry. "BG" in MK dictionary.
static final int | e_MKEntryBorderColor = 1
| Border color entry. "BC" in MK dictionary.
static final int | e_MKEntryDownCaption = 5
| Down caption (or alternate caption) entry. "AC" in MK dictionary. More...
static final int | e_MKEntryDownIcon = 8
| Down icon (or alternate icon) entry. "IX" in MK dictionary. More...
static final int | e_MKEntryIconCaptionRelation = 10
| Icon and caption relation entry. "TP" in MK dictionary. More...
static final int | e_MKEntryIconFit = 9
| Icon fit information entry. "IF" in MK dictionary. More...
static final int | e_MKEntryNormalCaption = 3
| Normal caption entry. "CA" in MK dictionary. More...
static final int | e_MKEntryNormalIcon = 6
| Normal icon entry. "I" in MK dictionary. More...
static final int | e_MKEntryRolloverCaption = 4
| Rollover caption entry. "RC" in MK dictionary. More...
static final int | e_MKEntryRolloverIcon = 7
| Rollover icon entry. "RI" in MK dictionary. More...
static final int | e_MKEntryRotation = 0
| Rotation entry. "R" in MK dictionary.
static final int | e_MKRelationCaptionAboveIcon = 3
| Caption above the icon.
static final int | e_MKRelationCaptionBelowIcon = 2
| Caption below the icon.
static final int | e_MKRelationCaptionLeft = 5
| Caption to the left of the icon.
static final int | e_MKRelationCaptionOvrlayOnIcon = 6
| Caption overlaid directly on the icon.
static final int | e_MKRelationCaptionRight = 4
| Caption to the right of the icon.
static final int | e_MKRelationNoCaption = 1
| No caption; icon only.
static final int | e_MKRelationNoIcon = 0
| No icon; captin only.
static final int | e_Movie = 19
| Annotation type: movie annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Note = 1
| Annotation type: note annotation, which is just "Text" annotation - one of standard annotation in <PDF reference 1.7>.
static final int | e_PagingSeal = 29
| Annotation type: paging seal annotation. A Foxit PDF SDK custom annotation type (not a standard annotation type).
static final int | e_Polygon = 7
| Annotation type: polygon annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_PolyLine = 8
| Annotation type: polyline annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Popup = 26
| Annotation type: pop-up annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_PrinterMark = 22
| Annotation type: printer's mark annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_PropertyBorderColor = 2
| Annotation property: border color. More...
static final int | e_PropertyCreationDate = 1
| Annotation property: creation date. More...
static final int | e_PropertyFillColor = 3
| Annotation property: fill color. More...
static final int | e_PropertyModifiedDate = 0
| Annotation property: modified date.
static final int | e_PSInk = 16
| Annotation type: pressure sensitive ink annotation.
static final int | e_Redact = 27
| Annotation type: redact annotation.
static final int | e_RichMedia = 28
| Annotation type: rich media annotation.
static final int | e_Screen = 21
| Annotation type: screen annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Sound = 18
| Annotation type: sound annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Square = 5
| Annotation type: square annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Squiggly = 11
| Annotation type: squiggly annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Stamp = 13
| Annotation type: stamp annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_StrikeOut = 12
| Annotation type: strikeout annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_TrapNet = 23
| Annotation type: trap network annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Underline = 10
| Annotation type: underline annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_UnknownType = 0
| Annotation type: unknown.
static final int | e_Watermark = 24
| Annotation type: watermark annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Widget = 20
| Annotation type: widget annotation. One of standard annotation in <PDF reference 1.7>. More...

## Detailed Description

Markup annotations are used primarily to mark up PDF documents. These annotations have text that appears as part of the annotation and may be displayed in other ways by a viewer application, such as in a Comments pane.
Class com.foxit.sdk.pdf.annots.Markup is derived from class Annot , and is also the base class for all PDF markup annotations. It offers the base functions to get/set markup annotation's common properties. For concrete markup annotation types, please refer to derived classes.
Function Annot.isMarkup can be used to judge if an annotation is a markup annotation.

Note
  Currently, following kinds of functions only support note, highlight, underline, strikeout, squiggly, square, circle, free text, stamp, caret, ink, line, polygon, polyline, file attachment annotations:
  - All the "set" functions in class Markup .
  - Function Annot.resetAppearanceStream (inherited from Markup 's parent class).

See also
  Annot

## Constructor & Destructor Documentation

## ◆ Markup()

com.foxit.sdk.pdf.annots.Markup.Markup | ( | Annot | annot | ) |

Constructor, with parent class object.

Parameters

  [in] | annot | Parent class object.

## Member Function Documentation

## ◆ addReply()

Note com.foxit.sdk.pdf.annots.Markup.addReply | ( |  | ) | throws com.foxit.sdk.PDFException

Add a new reply to the end of reply list.

Returns
  A new note annotation that represents the new reply annotation.

## ◆ addRichText()

void com.foxit.sdk.pdf.annots.Markup.addRichText | ( | String | content,
|  | RichTextStyle | style
| ) |  | throws com.foxit.sdk.PDFException

Add a new rich text string to the end.

Markup annotation's content can consist of several rich text strings. Specially, if current annotation is a freetext and its intent is "FreeTextTypewriter", text aligment of input style will be set to all rich text strings of current freetext annotation.

Parameters

  [in] | content | Text string used as content of the new rich text string. This should not be an empty string.
  [in] | style | Style data used for the new rich text string.

Returns
  None.

## ◆ addStateAnnot()

Note com.foxit.sdk.pdf.annots.Markup.addStateAnnot | ( | String | title,
|  | int | model,
|  | int | state
| ) |  | throws com.foxit.sdk.PDFException

Add a new state annotation.

A markup annotation may have one or several author-specific state associated with it. Each state is not specified in the annotation itself but in a separate note annotation.

- For state model com.foxit.sdk.pdf.annots.Markup.e_StateModelReview , this function will add a new state annotation once this function is called.
- For state model com.foxit.sdk.pdf.annots.Markup.e_StateModelMarked , this function will find the latest state annotation with this model and the same title as input parameter title: if find one, this function will change state value of the found state annotation and return the found state annotation directly; if not find any suitable state annotation, this function will add a new one and return the new state annotation.

Parameters

  [in] | title | Title for the new state annotation. Title can be used to identify the user who added current annotation. This can be an empty string but users are strongly recommended to set a meaningful title when using this function.
  [in] | model | State model for the new state annotation. It should be one of following values: com.foxit.sdk.pdf.annots.Markup.e_StateModelMarked com.foxit.sdk.pdf.annots.Markup.e_StateModelReview
  [in] | state | State value for the new state annotation. It should be one of following values: If parameter model is com.foxit.sdk.pdf.annots.Markup.e_StateModelMarked , the state should be com.foxit.sdk.pdf.annots.Markup.e_StateMarked or com.foxit.sdk.pdf.annots.Markup.e_StateUnmarked . If parameter model is com.foxit.sdk.pdf.annots.Markup.e_StateModelReview , the state should be com.foxit.sdk.pdf.annots.Markup.e_StateAccepted , com.foxit.sdk.pdf.annots.Markup.e_StateRejected , com.foxit.sdk.pdf.annots.Markup.e_StateCancelled , com.foxit.sdk.pdf.annots.Markup.e_StateCompleted , com.foxit.sdk.pdf.annots.Markup.e_StateDeferred , com.foxit.sdk.pdf.annots.Markup.e_StateFuture , or com.foxit.sdk.pdf.annots.Markup.e_StateNone .

Returns
  A note annotation which represents the new state annotation. Last modified date time of the returned state annotation would be set with current local system time by default.

## ◆ delete()

synchronized void com.foxit.sdk.pdf.annots.Markup.delete | ( |  | ) |

Clean up related C++ resources immediately.

Returns
  None.

Note
  Once this function is called, current object cannot be used anymore.

Reimplemented from com.foxit.sdk.pdf.annots.Annot.

Reimplemented in com.foxit.sdk.pdf.annots.FreeText, com.foxit.sdk.pdf.annots.FileAttachment, com.foxit.sdk.pdf.annots.Sound, com.foxit.sdk.pdf.annots.Stamp, com.foxit.sdk.pdf.annots.Caret, com.foxit.sdk.pdf.annots.Circle, com.foxit.sdk.pdf.annots.Ink, com.foxit.sdk.pdf.annots.Line, com.foxit.sdk.pdf.annots.Note, com.foxit.sdk.pdf.annots.Polygon, com.foxit.sdk.pdf.annots.PolyLine, com.foxit.sdk.pdf.annots.Square, com.foxit.sdk.pdf.annots.Highlight, com.foxit.sdk.pdf.annots.Redact, com.foxit.sdk.pdf.annots.Squiggly, com.foxit.sdk.pdf.annots.StrikeOut, com.foxit.sdk.pdf.annots.TextMarkup, and com.foxit.sdk.pdf.annots.Underline.

## ◆ getBorderOpacity()

float com.foxit.sdk.pdf.annots.Markup.getBorderOpacity | ( |  | ) | throws com.foxit.sdk.PDFException

Get the border opacity of the annotation.

Returns
  The opacity value. Valid range: 0.0 to 1.0. 0.0 means full transparency and 1.0 means full opaque.

## ◆ getCreationDateTime()

DateTime com.foxit.sdk.pdf.annots.Markup.getCreationDateTime | ( |  | ) | throws com.foxit.sdk.PDFException

Get creation date time.

Returns
  A date and time object that receives the creation date time. If there is no creation date time information, a date and time object with all 0 values would be returned.

## ◆ getFillOpacity()

float com.foxit.sdk.pdf.annots.Markup.getFillOpacity | ( |  | ) | throws com.foxit.sdk.PDFException

Get the fill opacity of the annotation.

Returns
  The opacity value. Valid range: 0.0 to 1.0. 0.0 means full transparency and 1.0 means full opaque.

## ◆ getGroupElements()

MarkupArray com.foxit.sdk.pdf.annots.Markup.getGroupElements | ( |  | ) | throws com.foxit.sdk.PDFException

Get an element (as markup annotation) from the group that current markup annotation belongs to.

Markup annotations can be grouped. The group consists of a primary annotation and one or more subordinate annotations. Some entries in the primary annotation are treated as group attributes that should apply to the group as a whole; the corresponding entries in the subordinate annotations should be ignored. These entries are contents, last modification time, fill color/border color, title, pop-up annotation, creation time, subject, and open status. So user should respect the group property: when a property of an annotation in group is changed, the other annotations in the same group should be changed too.
Operations that manipulate any annotation in a group, such as movement, cut, and copy, should be treated by viewer applications as acting on the entire group.

Returns
  An array that contains all the markup annotations in the group. If current annotation does not belong to a group, this function will return an empty array.

## ◆ getGroupHeader()

Markup com.foxit.sdk.pdf.annots.Markup.getGroupHeader | ( |  | ) | throws com.foxit.sdk.PDFException

Get the header annotation (as primary annotation) of the group that current markup annotation belongs to.

Markup annotations can be grouped. The group consists of a primary annotation and one or more subordinate annotations. Some entries in the primary annotation are treated as group attributes that should apply to the group as a whole; the corresponding entries in the subordinate annotations should be ignored. These entries are contents, last modification time, fill color/border color, title, pop-up annotation, creation time, subject, and open status. So user should respect the group property: when a property of an annotation in group is changed, the other annotations in the same group should be changed too.
Operations that manipulate any annotation in a group, such as movement, cut, and copy, should be treated by viewer applications as acting on the entire group.

Returns
  The header markup annotation of the group that current markup annotation belongs to. If the return value of function Annot.isEmpty (inherited from Markup's parent class) for the returned markup annotation object is true, that means current annotation does not belong to a group.

## ◆ getIntent()

String com.foxit.sdk.pdf.annots.Markup.getIntent | ( |  | ) | throws com.foxit.sdk.PDFException

Get intent name.

Following annotation types have predefined intent name:

- Free text annotation's predefined intent name: "FreeTextCallout", "FreeTextTypewriter". If no intent name is used, free text annotation would be shown as a text box.
- Line annotation's predefined intent name: "LineArrow", "LineDimension". If no intent name is used, line annotation would be shown as a common line.
- Polygon's predefined intent name: "PolygonCloud", "PolygonDimension". If no intent name is used, polygon annotation would be shown as a common polygon.
- Polyline annotation's predefined intent name: "PolyLineDimension". If no intent name is used, polyline annotation would be shown as a common polyline.

Returns
  The intent name string.

## ◆ getOpacity()

float com.foxit.sdk.pdf.annots.Markup.getOpacity | ( |  | ) | throws com.foxit.sdk.PDFException

Get opacity value.

This property has effect on markup annotation's appearance.

Returns
  The opacity value. Valid range: 0.0 to 1.0. 0.0 means full transparency and 1.0 means full opaque.

## ◆ getPopup()

Popup com.foxit.sdk.pdf.annots.Markup.getPopup | ( |  | ) | throws com.foxit.sdk.PDFException

Get related pop-up annotation.

Most markup annotations can have a pop-up annotation to show their content, except sound and free text annotations:

- For sound annotation, it does not have a pop-up annotation.
- For free text annotation, it shows text directly on the page, so no need to have a pop-up annotation.

Though, in some special(or error) PDF document, sound or free text annotation may have a pop-up annotation, they still do not need a pop-up annotation.

Returns
  The related pop-up annotation. If the return value of function Annot.isEmpty (inherited from Popup 's parent class) for the returned pop-up annotation is true, that means current markup annotation does not have a pop-up annotation.

## ◆ getReply()

Note com.foxit.sdk.pdf.annots.Markup.getReply | ( | int | index | ) | throws com.foxit.sdk.PDFException

Get a reply by index.

Parameters

  [in] | index | The index for a specified reply. Valid range: from 0 to (count-1). count is returned by function Markup.getReplyCount .

Returns
  A note annotation that represents the specified reply annotation.

## ◆ getReplyCount()

int com.foxit.sdk.pdf.annots.Markup.getReplyCount | ( |  | ) | throws com.foxit.sdk.PDFException

Count all replies.

Returns
  The count of replies.

## ◆ getRichTextContent()

String com.foxit.sdk.pdf.annots.Markup.getRichTextContent | ( | int | index | ) | throws com.foxit.sdk.PDFException

Get text string of a rich text string specified by index.

Markup annotation's content can consist of several rich text strings.

Parameters

  [in] | index | Index for a rich text string whose content is to be retrieved. Valid range: from 0 to (count-1). count is returned by function Markup.getRichTextCount .

Returns
  Text string for the specified rich text.

## ◆ getRichTextCount()

int com.foxit.sdk.pdf.annots.Markup.getRichTextCount | ( |  | ) | throws com.foxit.sdk.PDFException

Get the count of rich text strings.

Markup annotation's content can consist of several rich text strings.

Returns
  Count of rich text strings.

## ◆ getRichTextStyle()

RichTextStyle com.foxit.sdk.pdf.annots.Markup.getRichTextStyle | ( | int | index | ) | throws com.foxit.sdk.PDFException

Get style data of a rich text string specified by index.

Markup annotation's content can consist of several rich text strings.

Parameters

  [in] | index | Index for a rich text string whose style data is to be retrieved. Valid range: from 0 to (count-1). count is returned by function Markup.getRichTextCount .

Returns
  Style data for the specified rich text string.

## ◆ getStateAnnots()

NoteArray com.foxit.sdk.pdf.annots.Markup.getStateAnnots | ( | int | model | ) | throws com.foxit.sdk.PDFException

Get all state annotations in a specified state model.

A markup annotation may have one or several author-specific state associated with it. Each state is not specified in the annotation itself but in a separate note annotation.

Parameters

  [in] | model | State model. It should be one of following values: com.foxit.sdk.pdf.annots.Markup.e_StateModelMarked com.foxit.sdk.pdf.annots.Markup.e_StateModelReview

Returns
  A note annotation array which represents all state annotations in the specified state model. All the annotations in this array would be in a chronological order.

## ◆ getSubject()

String com.foxit.sdk.pdf.annots.Markup.getSubject | ( |  | ) | throws com.foxit.sdk.PDFException

Get subject string.

Returns
  Subject string.

## ◆ getTitle()

String com.foxit.sdk.pdf.annots.Markup.getTitle | ( |  | ) | throws com.foxit.sdk.PDFException

Get title string.

By convention, annotation's title can be used to identify the user who added current annotation.

Returns
  Title string.

## ◆ insertRichText()

void com.foxit.sdk.pdf.annots.Markup.insertRichText | ( | int | index,
|  | String | content,
|  | RichTextStyle | style
| ) |  | throws com.foxit.sdk.PDFException

Insert a new rich text string to the place which is specified by index.

Markup annotation's content can consist of several rich text strings. Specially, if current annotation is a freetext and its intent is "FreeTextTypewriter", text aligment of input style will be set to all rich text strings of current freetext annotation.

Parameters

  [in] | index | Index for a rich text string whose style data is to be inserted at. Valid range: from 0 to count. count is returned by function Markup.getRichTextCount . If input value is equal to rich text string count, that means to add the new rich text string to the end. In this case, this funcion equals to function Markup.addRichText .
  [in] | content | Text string used as content of the new rich text string. This should not be an empty string.
  [in] | style | Style data used for the new rich text string.

Returns
  None.

## ◆ isGrouped()

boolean com.foxit.sdk.pdf.annots.Markup.isGrouped | ( |  | ) | throws com.foxit.sdk.PDFException

Check whether current markup annotation is in a group or not.

Markup annotations can be grouped. The group consists of a primary annotation and one or more subordinate annotations. Some entries in the primary annotation are treated as group attributes that should apply to the group as a whole; the corresponding entries in the subordinate annotations should be ignored. These entries are contents, last modification time, fill color/border color, title, pop-up annotation, creation time, subject, and open status. So user should respect the group property: when a property of an annotation in group is changed, the other annotations in the same group should be changed too.
Operations that manipulate any annotation in a group, such as movement, cut, and copy, should be treated by viewer applications as acting on the entire group.

Returns
  true means current markup annotation is in a group. false means current markup annotation does not belong to any group.

## ◆ removeAllReplies()

boolean com.foxit.sdk.pdf.annots.Markup.removeAllReplies | ( |  | ) | throws com.foxit.sdk.PDFException

Remove all the replies.

Returns
  true means success, while false means failure.

## ◆ removeAllStateAnnots()

boolean com.foxit.sdk.pdf.annots.Markup.removeAllStateAnnots | ( |  | ) | throws com.foxit.sdk.PDFException

Remove all the state annotations.

State annotation is represented by note annotation, so, to remove state annotations means to remove this kind of note annotations (with their popup annotations if any) from the page.

Returns
  true means remove all the state annotations successfully or current annotation does not have any state annotation, while false means failure.

## ◆ removePopup()

boolean com.foxit.sdk.pdf.annots.Markup.removePopup | ( |  | ) | throws com.foxit.sdk.PDFException

Remove related pop-up annotation.

Returns
  true means that related pop-up annotation is removed successfully, while false means current markup annotation does not have a related pop-up annotation.

## ◆ removeReply()

boolean com.foxit.sdk.pdf.annots.Markup.removeReply | ( | int | index | ) | throws com.foxit.sdk.PDFException

Remove a reply by index.

If specified reply has its own replies, these sub replies will be removed at the same time.

Parameters

  [in] | index | The index for a specified reply to be removed. Valid range: from 0 to (count-1). count is returned by function Markup.getReplyCount .

Returns
  true means success, while false means failure.

## ◆ removeRichText()

void com.foxit.sdk.pdf.annots.Markup.removeRichText | ( | int | index | ) | throws com.foxit.sdk.PDFException

Remove a rich text string specified by index.

Markup annotation's content can consist of several rich text strings.

Parameters

  [in] | index | Index for a rich text string whose style data is to be inserted at. Valid range: from 0 to (count-1). count is returned by function Markup.getRichTextCount .

Returns
  None.

## ◆ setBorderOpacity()

void com.foxit.sdk.pdf.annots.Markup.setBorderOpacity | ( | float | opacity | ) | throws com.foxit.sdk.PDFException

Set the border opacity of the annotation.

This property has effect on markup annotation's appearance. If user wants the new opacity value has effect on annotation's appearance, please call function Annot.resetAppearanceStream after setting the new opacity value.

Parameters

  [in] | opacity | The new opacity value. Valid range: 0.0 to 1.0 . 0.0 means full transparency and 1.0 means full opaque.

Returns
  None.

## ◆ setCreationDateTime()

void com.foxit.sdk.pdf.annots.Markup.setCreationDateTime | ( | DateTime | date_time | ) | throws com.foxit.sdk.PDFException

Set creation date time.

Parameters

  [in] | date_time | The new date time to be set.

Returns
  None.

## ◆ setFillOpacity()

void com.foxit.sdk.pdf.annots.Markup.setFillOpacity | ( | float | opacity | ) | throws com.foxit.sdk.PDFException

Set the fill opacity of the annotation.

This property has effect on markup annotation's appearance. If user wants the new opacity value has effect on annotation's appearance, please call function Annot.resetAppearanceStream after setting the new opacity value.

Parameters

  [in] | opacity | The new opacity value. Valid range: 0.0 to 1.0 . 0.0 means full transparency and 1.0 means full opaque.

Returns
  None.

## ◆ setIntent()

void com.foxit.sdk.pdf.annots.Markup.setIntent | ( | String | intent | ) | throws com.foxit.sdk.PDFException

Set intent name.

Following annotation types have predefined intent name:

- Free text annotation's predefined intent name: "FreeTextCallout", "FreeTextTypewriter". If no intent name is used, free text annotation would be shown as a text box. If the intent name is FreeTextTypewriter, the border color will be removed.
- Line annotation's predefined intent name: "LineArrow", "LineDimension". If no intent name is used, line annotation would be shown as a common line.
  If a line annotation's intent is to be set to "LineArrow", the line annotation's line ending styles will be com.foxit.sdk.pdf.annots.Markup.e_EndingStyleNone for start point and com.foxit.sdk.pdf.annots.Markup.e_EndingStyleOpenArrow for end point by default.
- Polygon's predefined intent name: "PolygonCloud", "PolygonDimension". If no intent name is used, polygon annotation would be shown as a common polygon.
  If a polygon annotation's intent is to be set to "PolygonCloud", the polygon annotation's border style will be changed to com.foxit.sdk.pdf.annots.BorderInfo.e_Cloudy and border cloud intensity will be set to 2 by default.
- Polyline annotation's predefined intent name: "PolyLineDimension". If no intent name is used, polyline annotation would be shown as a common polyline.

If supported predefined intent name has been set to corresponding type of annotation, user should call function Annot.resetAppearanceStream to make the effect on annotation's appearance.

Parameters

  [in] | intent | New intent name string to be set. If it is an empty string, that means the intent property will not be used. Some annotation type have predefined intent name, please refer to "Details" part for more details. If this string is one of those unsupported intent name, this string will be ignored when set to corresponding annotations.

Returns
  None.

## ◆ setOpacity()

void com.foxit.sdk.pdf.annots.Markup.setOpacity | ( | float | opacity | ) | throws com.foxit.sdk.PDFException

Set opacity value.

This property has effect on markup annotation's appearance. If user wants the new opacity value has effect on annotation's appearance, please call function Annot.resetAppearanceStream after setting the new opacity value.

Parameters

  [in] | opacity | The new opacity value. Valid range: 0.0 to 1.0 . 0.0 means full transparency and 1.0 means full opaque.

Returns
  None.

## ◆ setPopup()

void com.foxit.sdk.pdf.annots.Markup.setPopup | ( | Popup | popup | ) | throws com.foxit.sdk.PDFException

Set related pop-up annotation.

Most markup annotations can have a pop-up annotation to show their content, except sound and free text annotations:

- For sound annotation, it does not have a pop-up annotation.
- For free text annotation, it shows text directly on the page, so no need to have a pop-up annotation.

So, this function does not allow to set pop-up annotation to sound and free text annotation.

Parameters

  [in] | popup | A valid pop-up annotation to be set to current markup annotation.

Returns
  None.

## ◆ setRichTextContent()

void com.foxit.sdk.pdf.annots.Markup.setRichTextContent | ( | int | index,
|  | String | content
| ) |  | throws com.foxit.sdk.PDFException

Set text string of a rich text string specified by index.

Markup annotation's content can consist of several rich text strings.

Parameters

  [in] | index | Index for a rich text string whose content is to be set. Valid range: from 0 to (count-1). count is returned by function Markup.getRichTextCount .
  [in] | content | Text string to be set as content for specified rich text. This should not be an empty string.

Returns
  None.

## ◆ setRichTextStyle()

void com.foxit.sdk.pdf.annots.Markup.setRichTextStyle | ( | int | index,
|  | RichTextStyle | style
| ) |  | throws com.foxit.sdk.PDFException

Set style data of a rich text string specified by index.

Markup annotation's content can consist of several rich text strings.
Specially, if current annotation is a freetext and its intent is "FreeTextTypewriter", text aligment of input style will be set to all rich text strings of current freetext annotation.

Parameters

  [in] | index | Index for a rich text string whose style data is to be retrieved. Valid range: from 0 to (count-1). count is returned by function Markup.getRichTextCount .
  [in] | style | Style data used to be set to specified rich text.

Returns
  None.

## ◆ setSubject()

void com.foxit.sdk.pdf.annots.Markup.setSubject | ( | String | subject | ) | throws com.foxit.sdk.PDFException

Set subject string.

Parameters

  [in] | subject | New subject string to be set.

Returns
  None.

## ◆ setTitle()

void com.foxit.sdk.pdf.annots.Markup.setTitle | ( | String | title | ) | throws com.foxit.sdk.PDFException

Set title string.

By convention, annotation's title can be used to identify the user who added current annotation.

Parameters

  [in] | title | New title string to be set.

Returns
  None.

## ◆ ungroup()

boolean com.foxit.sdk.pdf.annots.Markup.ungroup | ( |  | ) | throws com.foxit.sdk.PDFException

Ungroup current markup annotation from the group it belongs to.

- If current markup annotation is just the group header, this function will disband the whole group.
- If current markup annotation is just a member of a group, this function will only ungroup current markup annotation from the group it belongs to.
- If current markup annotation does not belong to any group, this function will do nothing and return false directly.

Returns
  true means success, while false means current markup annotation does not belong to any group.